import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/config/const.dart';
import 'package:flutter_mylibrary/http/http_data.dart';
import 'base_view_state.dart';

mixin BaseRequestModelController<T> on BaseViewState{

  T data;


  Future<HttpData> refreshData() async{
    return request((httpData, requestInfo) {
      this.data = httpData.data;
      requestInfo.onSuccess?.call(httpData);
      setIdle();
      refreshController.finishRefresh();
      return httpData;
    });
  }

  onCompleted(T data) {}

  ///获取一个公共的刷新控件
  Widget buildEasyRefreshWidget({
    ScrollController scrollController,
    Widget footWidget,
    ViewStateWidgetBuilder emptyWidgetBuilder,
    ViewStateWidgetBuilder errorWidgetBuilder,
    ViewStateModelWidgetListBuilder<T> widgetListBuilder,
    ViewStateModelWidgetBuilder<T> widgetBuilder,
    Widget busyWidget,
    bool showErrorWidget = true,
    bool showEmptyWidget = true,
    bool showBusyWidget = true,
    Function onLoad,
    Function onRefresh,
  }){
    return buildViewStateEasyRefresh<T>(
        data: data,
        scrollController: scrollController,
        footWidget: footWidget,
        errorWidgetBuilder: errorWidgetBuilder,
        emptyWidgetBuilder: emptyWidgetBuilder,
        widgetListBuilder: widgetListBuilder,
        widgetBuilder: widgetBuilder,
        busyWidget: busyWidget,
        showBusyWidget: showBusyWidget,
        showEmptyWidget: showEmptyWidget,
        showErrorWidget: showErrorWidget,
        onLoad: onLoad,
        onRefresh: onRefresh??(){
          refreshData();
        }
    );
  }



}